#ifndef _H_107273F53818D8DD152B34CCB07DE878_BoundingBoxArray_DCPS_H_
#define _H_107273F53818D8DD152B34CCB07DE878_BoundingBoxArray_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "BoundingBoxArray_.h"


namespace autoware_auto_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class BoundingBoxArray_TypeSupportInterface;

            typedef BoundingBoxArray_TypeSupportInterface * BoundingBoxArray_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < BoundingBoxArray_TypeSupportInterface> BoundingBoxArray_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < BoundingBoxArray_TypeSupportInterface> BoundingBoxArray_TypeSupportInterface_out;


            class BoundingBoxArray_DataWriter;

            typedef BoundingBoxArray_DataWriter * BoundingBoxArray_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < BoundingBoxArray_DataWriter> BoundingBoxArray_DataWriter_var;
            typedef DDS_DCPSInterface_out < BoundingBoxArray_DataWriter> BoundingBoxArray_DataWriter_out;


            class BoundingBoxArray_DataReader;

            typedef BoundingBoxArray_DataReader * BoundingBoxArray_DataReader_ptr;
            typedef DDS_DCPSInterface_var < BoundingBoxArray_DataReader> BoundingBoxArray_DataReader_var;
            typedef DDS_DCPSInterface_out < BoundingBoxArray_DataReader> BoundingBoxArray_DataReader_out;


            class BoundingBoxArray_DataReaderView;

            typedef BoundingBoxArray_DataReaderView * BoundingBoxArray_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < BoundingBoxArray_DataReaderView> BoundingBoxArray_DataReaderView_var;
            typedef DDS_DCPSInterface_out < BoundingBoxArray_DataReaderView> BoundingBoxArray_DataReaderView_out;

            struct BoundingBoxArray_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < BoundingBoxArray_, struct BoundingBoxArray_Seq_uniq_> BoundingBoxArray_Seq;
            typedef DDS_DCPSSequence_var < BoundingBoxArray_Seq> BoundingBoxArray_Seq_var;
            typedef DDS_DCPSSequence_out < BoundingBoxArray_Seq> BoundingBoxArray_Seq_out;

            class  BoundingBoxArray_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef BoundingBoxArray_TypeSupportInterface_ptr _ptr_type;
                typedef BoundingBoxArray_TypeSupportInterface_var _var_type;

                static BoundingBoxArray_TypeSupportInterface_ptr _duplicate (BoundingBoxArray_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BoundingBoxArray_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static BoundingBoxArray_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BoundingBoxArray_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                BoundingBoxArray_TypeSupportInterface_ptr _this () { return this; }


            protected:
                BoundingBoxArray_TypeSupportInterface () {};
                ~BoundingBoxArray_TypeSupportInterface () {};
            private:
                BoundingBoxArray_TypeSupportInterface (const BoundingBoxArray_TypeSupportInterface &);
                BoundingBoxArray_TypeSupportInterface & operator = (const BoundingBoxArray_TypeSupportInterface &);
            };

            class  BoundingBoxArray_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef BoundingBoxArray_DataWriter_ptr _ptr_type;
                typedef BoundingBoxArray_DataWriter_var _var_type;

                static BoundingBoxArray_DataWriter_ptr _duplicate (BoundingBoxArray_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BoundingBoxArray_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static BoundingBoxArray_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BoundingBoxArray_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                BoundingBoxArray_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const BoundingBoxArray_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const BoundingBoxArray_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const BoundingBoxArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const BoundingBoxArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const BoundingBoxArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const BoundingBoxArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const BoundingBoxArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const BoundingBoxArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const BoundingBoxArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const BoundingBoxArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (BoundingBoxArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BoundingBoxArray_& instance_data) = 0;

            protected:
                BoundingBoxArray_DataWriter () {};
                ~BoundingBoxArray_DataWriter () {};
            private:
                BoundingBoxArray_DataWriter (const BoundingBoxArray_DataWriter &);
                BoundingBoxArray_DataWriter & operator = (const BoundingBoxArray_DataWriter &);
            };

            class  BoundingBoxArray_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef BoundingBoxArray_DataReader_ptr _ptr_type;
                typedef BoundingBoxArray_DataReader_var _var_type;

                static BoundingBoxArray_DataReader_ptr _duplicate (BoundingBoxArray_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BoundingBoxArray_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static BoundingBoxArray_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BoundingBoxArray_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                BoundingBoxArray_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (BoundingBoxArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (BoundingBoxArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (BoundingBoxArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (BoundingBoxArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (BoundingBoxArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (BoundingBoxArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (BoundingBoxArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (BoundingBoxArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (BoundingBoxArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (BoundingBoxArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (BoundingBoxArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (BoundingBoxArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (BoundingBoxArray_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (BoundingBoxArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BoundingBoxArray_& instance) = 0;

            protected:
                BoundingBoxArray_DataReader () {};
                ~BoundingBoxArray_DataReader () {};
            private:
                BoundingBoxArray_DataReader (const BoundingBoxArray_DataReader &);
                BoundingBoxArray_DataReader & operator = (const BoundingBoxArray_DataReader &);
            };

            class  BoundingBoxArray_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef BoundingBoxArray_DataReaderView_ptr _ptr_type;
                typedef BoundingBoxArray_DataReaderView_var _var_type;

                static BoundingBoxArray_DataReaderView_ptr _duplicate (BoundingBoxArray_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BoundingBoxArray_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static BoundingBoxArray_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BoundingBoxArray_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                BoundingBoxArray_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (BoundingBoxArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (BoundingBoxArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (BoundingBoxArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (BoundingBoxArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (BoundingBoxArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (BoundingBoxArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (BoundingBoxArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (BoundingBoxArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (BoundingBoxArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (BoundingBoxArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (BoundingBoxArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (BoundingBoxArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (BoundingBoxArray_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (BoundingBoxArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BoundingBoxArray_& instance) = 0;

            protected:
                BoundingBoxArray_DataReaderView () {};
                ~BoundingBoxArray_DataReaderView () {};
            private:
                BoundingBoxArray_DataReaderView (const BoundingBoxArray_DataReaderView &);
                BoundingBoxArray_DataReaderView & operator = (const BoundingBoxArray_DataReaderView &);
            };
        }

    }

}

#endif
