#ifndef _H_3B53758CE669278CC677332B6B3A5545_HighLevelControlCommand_DCPS_H_
#define _H_3B53758CE669278CC677332B6B3A5545_HighLevelControlCommand_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "HighLevelControlCommand_.h"


namespace autoware_auto_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class HighLevelControlCommand_TypeSupportInterface;

            typedef HighLevelControlCommand_TypeSupportInterface * HighLevelControlCommand_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < HighLevelControlCommand_TypeSupportInterface> HighLevelControlCommand_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < HighLevelControlCommand_TypeSupportInterface> HighLevelControlCommand_TypeSupportInterface_out;


            class HighLevelControlCommand_DataWriter;

            typedef HighLevelControlCommand_DataWriter * HighLevelControlCommand_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < HighLevelControlCommand_DataWriter> HighLevelControlCommand_DataWriter_var;
            typedef DDS_DCPSInterface_out < HighLevelControlCommand_DataWriter> HighLevelControlCommand_DataWriter_out;


            class HighLevelControlCommand_DataReader;

            typedef HighLevelControlCommand_DataReader * HighLevelControlCommand_DataReader_ptr;
            typedef DDS_DCPSInterface_var < HighLevelControlCommand_DataReader> HighLevelControlCommand_DataReader_var;
            typedef DDS_DCPSInterface_out < HighLevelControlCommand_DataReader> HighLevelControlCommand_DataReader_out;


            class HighLevelControlCommand_DataReaderView;

            typedef HighLevelControlCommand_DataReaderView * HighLevelControlCommand_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < HighLevelControlCommand_DataReaderView> HighLevelControlCommand_DataReaderView_var;
            typedef DDS_DCPSInterface_out < HighLevelControlCommand_DataReaderView> HighLevelControlCommand_DataReaderView_out;

            struct HighLevelControlCommand_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < HighLevelControlCommand_, struct HighLevelControlCommand_Seq_uniq_> HighLevelControlCommand_Seq;
            typedef DDS_DCPSSequence_var < HighLevelControlCommand_Seq> HighLevelControlCommand_Seq_var;
            typedef DDS_DCPSSequence_out < HighLevelControlCommand_Seq> HighLevelControlCommand_Seq_out;

            class  HighLevelControlCommand_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef HighLevelControlCommand_TypeSupportInterface_ptr _ptr_type;
                typedef HighLevelControlCommand_TypeSupportInterface_var _var_type;

                static HighLevelControlCommand_TypeSupportInterface_ptr _duplicate (HighLevelControlCommand_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HighLevelControlCommand_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static HighLevelControlCommand_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HighLevelControlCommand_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                HighLevelControlCommand_TypeSupportInterface_ptr _this () { return this; }


            protected:
                HighLevelControlCommand_TypeSupportInterface () {};
                ~HighLevelControlCommand_TypeSupportInterface () {};
            private:
                HighLevelControlCommand_TypeSupportInterface (const HighLevelControlCommand_TypeSupportInterface &);
                HighLevelControlCommand_TypeSupportInterface & operator = (const HighLevelControlCommand_TypeSupportInterface &);
            };

            class  HighLevelControlCommand_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef HighLevelControlCommand_DataWriter_ptr _ptr_type;
                typedef HighLevelControlCommand_DataWriter_var _var_type;

                static HighLevelControlCommand_DataWriter_ptr _duplicate (HighLevelControlCommand_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HighLevelControlCommand_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static HighLevelControlCommand_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HighLevelControlCommand_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                HighLevelControlCommand_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const HighLevelControlCommand_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const HighLevelControlCommand_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const HighLevelControlCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const HighLevelControlCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const HighLevelControlCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const HighLevelControlCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const HighLevelControlCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const HighLevelControlCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const HighLevelControlCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const HighLevelControlCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (HighLevelControlCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HighLevelControlCommand_& instance_data) = 0;

            protected:
                HighLevelControlCommand_DataWriter () {};
                ~HighLevelControlCommand_DataWriter () {};
            private:
                HighLevelControlCommand_DataWriter (const HighLevelControlCommand_DataWriter &);
                HighLevelControlCommand_DataWriter & operator = (const HighLevelControlCommand_DataWriter &);
            };

            class  HighLevelControlCommand_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef HighLevelControlCommand_DataReader_ptr _ptr_type;
                typedef HighLevelControlCommand_DataReader_var _var_type;

                static HighLevelControlCommand_DataReader_ptr _duplicate (HighLevelControlCommand_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HighLevelControlCommand_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static HighLevelControlCommand_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HighLevelControlCommand_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                HighLevelControlCommand_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (HighLevelControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HighLevelControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HighLevelControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HighLevelControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HighLevelControlCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HighLevelControlCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HighLevelControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HighLevelControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HighLevelControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HighLevelControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HighLevelControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HighLevelControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HighLevelControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HighLevelControlCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HighLevelControlCommand_& instance) = 0;

            protected:
                HighLevelControlCommand_DataReader () {};
                ~HighLevelControlCommand_DataReader () {};
            private:
                HighLevelControlCommand_DataReader (const HighLevelControlCommand_DataReader &);
                HighLevelControlCommand_DataReader & operator = (const HighLevelControlCommand_DataReader &);
            };

            class  HighLevelControlCommand_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef HighLevelControlCommand_DataReaderView_ptr _ptr_type;
                typedef HighLevelControlCommand_DataReaderView_var _var_type;

                static HighLevelControlCommand_DataReaderView_ptr _duplicate (HighLevelControlCommand_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HighLevelControlCommand_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static HighLevelControlCommand_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HighLevelControlCommand_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                HighLevelControlCommand_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (HighLevelControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HighLevelControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HighLevelControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HighLevelControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HighLevelControlCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HighLevelControlCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HighLevelControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HighLevelControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HighLevelControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HighLevelControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HighLevelControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HighLevelControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HighLevelControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HighLevelControlCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HighLevelControlCommand_& instance) = 0;

            protected:
                HighLevelControlCommand_DataReaderView () {};
                ~HighLevelControlCommand_DataReaderView () {};
            private:
                HighLevelControlCommand_DataReaderView (const HighLevelControlCommand_DataReaderView &);
                HighLevelControlCommand_DataReaderView & operator = (const HighLevelControlCommand_DataReaderView &);
            };
        }

    }

}

#endif
