#ifndef _H_2162CAC00CF0C6AE2DB4938BC2A8E5CE_VehicleKinematicState__H_
#define _H_2162CAC00CF0C6AE2DB4938BC2A8E5CE_VehicleKinematicState__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "autoware_auto_msgs/msg/dds_opensplice/TrajectoryPoint_.h"
#include "geometry_msgs/msg/dds_opensplice/Transform_.h"


namespace autoware_auto_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  VehicleKinematicState_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::autoware_auto_msgs::msg::dds_::TrajectoryPoint_ state_;
                ::geometry_msgs::msg::dds_::Transform_ delta_;
            };

            typedef DDS_DCPSStruct_var<VehicleKinematicState_> VehicleKinematicState__var;
            typedef DDS_DCPSStruct_out < VehicleKinematicState_> VehicleKinematicState__out;

        }

    }

}

#endif /* _H_2162CAC00CF0C6AE2DB4938BC2A8E5CE_VehicleKinematicState__H_ */
